'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _extends2 = require('babel-runtime/helpers/extends');

var _extends3 = _interopRequireDefault(_extends2);

exports.default = triggerHooksOnServer;

var _getAllComponents = require('./getAllComponents');

var _getAllComponents2 = _interopRequireDefault(_getAllComponents);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function triggerHooksOnServer(renderProps) {
  var hooks = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  var locals = arguments[2];
  var _ref = arguments[3];
  var _ref$onComponentError = _ref.onComponentError,
      onComponentError = _ref$onComponentError === undefined ? null : _ref$onComponentError;
  var callback = arguments[4];

  var args = (0, _extends3.default)({}, renderProps, locals);

  var promises = (0, _getAllComponents2.default)(renderProps.components).map(function (component) {
    var routerHooks = component[_constants.routerHookPropName];
    if (!routerHooks) return null;
    var runHooks = hooks.map(function (key) {
      return routerHooks[key];
    }).filter(function (f) {
      return f;
    });
    if (runHooks.length < 1) return null;
    return runHooks.reduce(function (total, current) {
      return total.then(function () {
        return current(args);
      });
    }, _promise2.default.resolve()).catch(function (err) {
      return onComponentError({ Component: component, error: err });
    });
  }).filter(function (p) {
    return p;
  });

  if (callback) {
    _promise2.default.all(promises).then(function () {
      callback();
    }).catch(callback);
    return null;
  }
  return _promise2.default.all(promises);
}